> ## Documentation Index
> Fetch the complete documentation index at: https://developers.circle.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Get a list of messages

> Retrieves message and attestation details for CCTP V1 messages.



## OpenAPI

````yaml openapi/cctp.yaml get /v1/messages/{sourceDomainId}/{transactionHash}
openapi: 3.0.2
info:
  version: '1.0'
  title: Cross-Chain Transfer Protocol (CCTP)
  description: >
    Circle's Cross-Chain Transfer Protocol enables you to build seamless user
    experiences for sending and transacting USDC natively across blockchains.


    CCTP endpoints enable advanced capabilities such as fetching attestations
    for faster-than-finality burn events, verifying public keys across versions,
    accessing transaction details, querying Fast Transfer allowances and fees,
    and initiating re-attestation processes.
servers:
  - url: https://iris-api-sandbox.circle.com
  - url: https://iris-api.circle.com
security: []
tags:
  - name: CCTP
    description: Cross-Chain Transfer Protocol endpoints
  - name: CCTP V1 (Legacy)
    description: Legacy Cross-Chain Transfer Protocol endpoints
paths:
  /v1/messages/{sourceDomainId}/{transactionHash}:
    get:
      tags:
        - CCTP V1 (Legacy)
      summary: Get a list of messages
      description: Retrieves message and attestation details for CCTP V1 messages.
      operationId: getMessages
      parameters:
        - $ref: '#/components/parameters/SourceDomainIdPath'
        - $ref: '#/components/parameters/TransactionHashPath'
      responses:
        '200':
          description: >-
            Successfully retrieved messages for the given domain and transaction
            hash.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/MessagesV1Response'
              examples:
                complete:
                  value:
                    messages:
                      - attestation: >-
                          0xdc485fb2f9a8f68c871f4ca7386dee9086ff9d4387756990c9c4b9280338325252866861f9495dce3128cd524d525c44e8e7b731dedd3098a618dcc19c45be1e1c
                        message: >-
                          0x00000000000000050000000300000000000194c2a65fc943419a5ad590042fd67c9791fd015acf53a54cc823edb8ff81b9ed722e00000000000000000000000019330d10d9cc8751218eaf51e8885d058642e08a000000000000000000000000fc05ad74c6fe2e7046e091d6ad4f660d2a15976200000000c6fa7af3bedbad3a3d65f36aabc97431b1bbe4c2d2f6e0e47ca60203452f5d610000000000000000000000002d475f4746419c83be23056309a8e2ac33b30e3b0000000000000000000000000000000000000000000000000000000002b67df0feae5e08f5e6bf04d8c1de7dada9235c56996f4420b14371d6c6f3ddd2f2da78
                        eventNonce: '9682'
                pending confirmations:
                  value:
                    messages:
                      - attestation: PENDING
                        message: >-
                          0x00000000000000050000000300000000000194c2a65fc943419a5ad590042fd67c9791fd015acf53a54cc823edb8ff81b9ed722e00000000000000000000000019330d10d9cc8751218eaf51e8885d058642e08a000000000000000000000000fc05ad74c6fe2e7046e091d6ad4f660d2a15976200000000c6fa7af3bedbad3a3d65f36aabc97431b1bbe4c2d2f6e0e47ca60203452f5d610000000000000000000000002d475f4746419c83be23056309a8e2ac33b30e3b0000000000000000000000000000000000000000000000000000000002b67df0feae5e08f5e6bf04d8c1de7dada9235c56996f4420b14371d6c6f3ddd2f2da78
                        eventNonce: '9682'
        '404':
          $ref: '#/components/responses/NotFound'
components:
  parameters:
    SourceDomainIdPath:
      name: sourceDomainId
      description: Source domain identifier for a blockchain on CCTP.
      in: path
      required: true
      schema:
        type: integer
        minimum: 0
        example: 3
    TransactionHashPath:
      name: transactionHash
      description: Transaction hash that contains the message being transferred.
      in: path
      required: true
      schema:
        type: string
        pattern: ^0x[a-fA-F0-9]{64}$
        example: '0x912f22a13e9ccb979b621500f6952b2afd6e75be7eadaed93fc2625fe11c52a2'
  schemas:
    MessagesV1Response:
      title: GetMessagesResponse
      type: object
      description: >-
        CCTP messages corresponding to a given transaction hash and source
        domain ID.
      required:
        - messages
      properties:
        messages:
          type: array
          items:
            $ref: '#/components/schemas/MessageV1'
    MessageV1:
      type: object
      required:
        - attestation
        - message
        - eventNonce
      properties:
        attestation:
          type: string
          description: >-
            Signed attestation. This is 'PENDING' if the event has been seen but
            the attestation is still pending block confirmations.
          example: >-
            0x6edd90f4a0ad0212fd9fbbd5058a25aa8ee10ce77e4fc143567bbe73fb6e164f384a3e14d350c8a4fc50b781177297e03c16b304e8d7656391df0f59a75a271f1b
        message:
          type: string
          description: Raw message bytes returned in hex format.
          example: >-
            0x00000000000000050000000300000000000194c2a65fc943419a5ad590042fd67c9791fd015acf53a54cc823edb8ff81b9ed722e00000000000000000000000019330d10d9cc8751218eaf51e8885d058642e08a000000000000000000000000fc05ad74c6fe2e7046e091d6ad4f660d2a15976200000000c6fa7af3bedbad3a3d65f36aabc97431b1bbe4c2d2f6e0e47ca60203452f5d610000000000000000000000002d475f4746419c83be23056309a8e2ac33b30e3b0000000000000000000000000000000000000000000000000000000002b67df0feae5e08f5e6bf04d8c1de7dada9235c56996f4420b14371d6c6f3ddd2f2da78
        eventNonce:
          $ref: '#/components/schemas/MessageNonce'
    MessageNonce:
      type: string
      description: The nonce associated with the message.
      example: '9682'
    XRequestId:
      type: string
      format: uuid
      description: >-
        A unique identifier, which can be helpful for identifying a request when
        communicating with Circle support.
      example: 2adba88e-9d63-44bc-b975-9b6ae3440dde
  responses:
    NotFound:
      content:
        application/json:
          schema:
            type: object
            title: NotFoundResponse
            required:
              - code
              - message
            properties:
              code:
                type: integer
                description: Code that corresponds to the error.
              message:
                type: string
                description: Message that describes the error.
            example:
              code: 404
              message: Not found.
      description: Specified resource was not found.
      headers:
        X-Request-Id:
          $ref: '#/components/headers/XRequestId'
  headers:
    XRequestId:
      description: >
        Developer-provided header parameter or Circle-generated universally
        unique identifier (UUID v4). Useful for identifying a specific request
        when communicating with Circle Support.
      schema:
        $ref: '#/components/schemas/XRequestId'

````